<?php

/**
 * DataTreeObject_Deliverable Class.
 * TODO: Allow  the resposible user to upload the deliverable via Gollem
 *
 * $Horde: thor/lib/Item/Deliverable.php,v 1.12 2004/08/26 16:52:52 carlos Exp $
 *
 * @author  Carlos Pedrinaci <cpedrinaci@yahoo.es>
 * @version $Revision: 1.12 $
 * @package Thor
 */
class DataTreeObject_Deliverable extends DataTreeObject_Item {

    /**
     * Variable required for Dynamic Binding of Items
     */
    var $_objectType = 'thor/Deliverable';

    function DataTreeObject_Deliverable($name)
    {
        parent::DataTreeObject_Item($name);
    }

    function _toAttributes()
    { 
        //Specific Attributes
        $attributes[] = array('name'  => 'deliverable',
                              'key'   => 'due_date',
                              'value' => $this->data['deliverable_due_date']);
        $attributes[] = array('name'  => 'deliverable',
                              'key'   => 'responsible_id',
                              'value' => $this->data['deliverable_responsible_id']);   
                              
        if (isset($this->data['deliverable_delivery_date'])) {
            $attributes[] = array('name'  => 'deliverable',
                                  'key'   => 'delivery_date',
                                  'value' => $this->data['deliverable_delivery_date']);
            $attributes[] = array('name'  => 'deliverable',
                                  'key'   => 'file_link',
                                  'value' => $this->data['deliverable_file_link']);         
        }
        
        return array_merge(parent::_toAttributes(),$attributes);
    }
    
    function toArray()
    {
        $array['deliverable_due_date'] = $this->data['deliverable_due_date'];  
        $array['deliverable_responsible_id'] = $this->data['deliverable_responsible_id'];
        $array['deliverable_delivery_date'] = isset($this->data['deliverable_delivery_date']) ? $this->data['deliverable_delivery_date'] : null; 
        $array['deliverable_file_link'] = isset($this->data['deliverable_file_link']) ? $this->data['deliverable_file_link'] : null;  
        return array_merge(parent::toArray(), $array);     
    }
    
    function fromArray(&$info)
    {
        $this->data['deliverable_due_date'] = strtotime($info['deliverable_due_date']); 
        $this->data['deliverable_responsible_id'] = $info['deliverable_responsible_id']; 
        parent::fromArray($info);
    }
     
    function setFileLink($link)
    {  
        $this->set('deliverable_delivery_date', time());
        $this->data['deliverable_file_link'] = $link;
    }
    
    // Methods of Thor_Item to be implemented
    function showInformation()
    {
        global $prefs, $thor;
        
        $itemData = $this->toArray();
        $leftHeaderText = $this->getShortName();
        $project = $thor->_projectsContainer->getProject($itemData['project_id']);
        if ($project->isUserOfKind(Auth::getAuth(), USERS_ADMINS)) {
            $url = Util::addParameter('item.php', array('item_id' => $itemData['item_id'], 
                                                                                 'project_id' =>$itemData['project_id'],
                                                                                 'actionID' => EDIT_ITEM));
            
            $rightHeaderText = Horde::link(Horde::applicationUrl($url), _("Edit Item")) . Horde::img('add.png', _("Edit Item"), 'hspace="2"');
        } else {
            $rightHeaderText = '';
        }
        $insertBreak = true;
        require THOR_TEMPLATES . '/section-header.inc';
        require THOR_TEMPLATES . '/view/Deliverable/description.inc';
        require THOR_TEMPLATES . '/view/footer.inc';
    }
    
    function initialize()
    {
        parent::initialize();
    }
    
    function _destroy()
    {
        parent::_destroy();
    }

}


/**
 * DeliverableForm Class
 *
 * $Horde: thor/lib/Item/Deliverable.php,v 1.12 2004/08/26 16:52:52 carlos Exp $
 *
 * @author  Carlos Pedrinaci <cpedrinaci@yahoo.es>
 * @version $Revision: 1.12 $
 * @package Thor
 */
class DeliverableForm extends Horde_Form {

    var $_useFormToken = false;

    function DeliverableForm(&$vars)
    {
        global $thor;
        
        $pid = $vars->get('project_id');
        $item_id = $vars->get('item_id');
        $title = empty($item_id) ? _("Create Deliverable - Step 2") : _("Edit Deliverable");
        parent::Horde_Form($vars, $title);
        
        /* Retrieve the project*/ 
        $project = &$thor->_projectsContainer->getProject($pid);
        $list = array();
        $users = $project->listUsers(USERS_TEAM, 0, 0);
        foreach ($users as $user) {
            $list[$user] = $user;
        }
        $params2 = array($list, true);
        $year = date('Y');
        $params = array($year, $year + 20);
        $this->addVariable(_("Due Date"), 'deliverable_due_date', 'monthdayyear', true, false, null, $params);
        $this->addVariable(_("Responsible"), 'deliverable_responsible_id', 'enum', true, false, null, $params2);
    }
    
}