<?php
// Projects Dev_Status constants
/** @constant PLANNING  */
define('PLANNING', 0);
/** @constant PRE_ALPHA */
define('PRE_ALPHA', 1);
/** @constant ALPHA */
define('ALPHA', 2);
/** @constant BETA */
define('BETA', 4);
/** @constant STABLE  */
define('STABLE', 8);

// Projects Operating Systems flags
define('AIX', 1);
define('BEOS', 2);
define('BSD', 4);
define('GNU_HURD', 8);
define('HP_UX', 16);
define('IRIX', 32);
define('LINUX', 64);
define('MACOS_9', 128);
define('MACOS_X', 256);
define('MS_DOS', 512);
define('OTHER_OS', 1024);
define('OS_2', 2048);
define('OS_INDEP', 4096);
define('PALM_OS', 8192);
define('SCO', 16384);
define('SUNOS_SOLARIS', 32768);
define('WIN_95', 65536);
define('WIN_98', 131072);
define('WIN_2000', 262144);
define('WIN_CE', 524288);
define('WIN_NT', 1048576);
define('WIN_XP', 2097152);

//Projects Programming Languages flags
define('ADA', 1);
define('ASP', 2);
define('ASSEMBLY', 4);
define('C', 8);
define('CSHARP', 16);
define('CPP', 32);
define('COLD_FUSION', 64);
define('DELPHI', 128);
define('EIFFEL', 256);
define('FORTRAN', 512);
define('JAVA', 1024);
define('JS', 2048);
define('LISP', 4096);
define('MODULA', 8192);
define('OBJ_C', 16384);
define('OBJ_PASCAL', 32768);
define('OTHER_LANG', 65536);
define('PASCAL', 131072);
define('PERL', 262144);
define('PHP', 524288);
define('PL_SQL', 1048576);
define('PROLOG', 2097152);
define('PYTHON', 4194304);
define('RUBY', 8388608);
define('SCHEME', 16777216);
define('SMALLTALK', 33554432);
define('TCL_TK', 67108864);
define('SHELL', 134217728);
define('VB', 268435456);

//Projects Environments
define('COCOA', 1);
define('CONSOLE', 2);
define('CURSES', 4);
define('DAEMON', 8);
define('GNOME', 16);
define('KDE', 32);
define('NEWT', 64);
define('OTHER_ENV', 128);
define('PDA', 256);
define('WEB_ENV', 512);
define('WIN32', 1024);
define('X11', 2048);

/**
 * DataTreeObject_SoftwareProject Class.
 *
 * $Horde: thor/lib/Project/SoftwareProject.php,v 1.15 2004/10/11 22:07:21 carlos Exp $
 *
 * @author  Carlos Pedrinaci <cpedrinaci@yahoo.es>
 * @version $Revision: 1.15 $
 * @package Thor
 */
class DataTreeObject_SoftwareProject extends DataTreeObject_Project {

    /**
     * Variable required for Dynamic Binding of Projects
     */
    var $_objectType = 'thor/SoftwareProject';

    function DataTreeObject_SoftwareProject($name)
    {
        parent::DataTreeObject_Project($name);
    }
       
    function _toAttributes()
    {                                    
        $attributes[] = array('name'  => 'software',
                              'key'   => 'dev_status',
                              'value' => $this->data['software_dev_status']);
        $attributes[] = array('name'  => 'software',
                              'key'   => 'environment',
                              'value' => $this->data['software_environment']);   
        $attributes[] = array('name'  => 'software',
                              'key'   => 'os',
                              'value' => $this->data['software_os']);  
        $attributes[] = array('name'  => 'software',
                              'key'   => 'prog_lang',
                              'value' => $this->data['software_prog_lang']);                                                            
       
        return array_merge(parent::_toAttributes(),$attributes);
    }
    
    function toArray()
    {   global $thor;
        
        $array['software_dev_status'] = $this->data['software_dev_status'];
        $array['software_environment'] = $thor->getSelectedFlags($this->getEnvList(), $this->data['software_environment']);   
        $array['software_os'] = $thor->getSelectedFlags($this->getOSList(), $this->data['software_os']);  
        $array['software_prog_lang'] = $thor->getSelectedFlags($this->getProgLangList(), $this->data['software_prog_lang']);
        return array_merge(parent::toArray(), $array);     
    }
    
    function fromArray(&$info)
    {
        $this->data['software_dev_status'] = $info['software_dev_status'];    
        $this->data['software_environment'] = array_sum($info['software_environment']);
        $this->data['software_os'] = array_sum($info['software_os']);
        $this->data['software_prog_lang'] = array_sum($info['software_prog_lang']);
        parent::fromArray($info);
    }
    
    function getDevStatusList()
    {
        return array(PLANNING => _("Planning"), PRE_ALPHA => _("Pre-Alpha"),
                             ALPHA => _("Alpha"),  BETA => _("Beta"),
                             STABLE =>_("Stable"));
    }
    
    function getOSList()
    {
        return array(AIX => "AIX", BEOS => "BeOS", BSD => "BSD", GNU_HURD => "GNU Hurd",
                             HP_UX => "HP-UX", IRIX => "IRIX", LINUX => "Linux", MACOS_9 => "MacOS 9",
                             MACOS_X => "MacOS X", MS_DOS => "MS-DOS", OTHER_OS => "Other",
                             OS_2 => "OS/2", OS_INDEP => _("Operating System independent"),
                             PALM_OS => "Palm OS", SCO => "SCO", SUNOS_SOLARIS => "SunOS/Solaris",
                             WIN_95 => "Windows 95", WIN_98 => "Windows 98",
                             WIN_2000 => "Windows 2000", WIN_CE => "Windows CE",
                             WIN_NT => "Windows NT", WIN_XP => "Windows XP");
    }
    
    function getProgLangList()
    {
        return array(ADA => "Ada", ASP => "ASP", ASSEMBLY => _("Assembly"), C => "C",
                              CSHARP => "C#", CPP => "C++", COLD_FUSION => "Cold Fusion",
                              DELPHI => "Delphi/Kylix",  EIFFEL => "Eiffel", FORTRAN => "Fortran", 
                              JAVA => "Java", JS => "JavaScript", LISP => "Lisp", 
                              MODULA => "Modula", OBJ_C => "Objective C", 
                              OBJ_PASCAL => "Object Pascal", OTHER_LANG => "Other", PASCAL => "Pascal",
                              PERL => "Perl", PHP => "PHP", PL_SQL => "PL/SQL", PROLOG => "Prolog",
                              PYTHON => "Python", RUBY => "Ruby", SCHEME => "Scheme", 
                              SMALLTALK => "Smalltalk", TCL_TK => "Tcl/Tk", SHELL => "Shell", 
                              VB => "Visual Basic");
    }
    
    function getEnvList()
    {
        return array(COCOA => "Cocoa (MacOS X)", CONSOLE => _("Console (Text Based)"),
                             CURSES => "Curses", DAEMON => _("No Input/Output (Daemon)"),
                             GNOME => "Gnome", KDE => "KDE", NEWT => "Newt",
                             OTHER_ENV => _("Other Environment"), PDA => "Handheld/PDA", 
                             WEB_ENV => _("Web Environment"), WIN32 => "Win32 (MS Windows)",
                             X11 => "X Windows");
    }
    
    /**
     * Shows the Project information
     *
     * @param string optional $insertBreak Insert a break before adding the content?
     * @param boolean optional $short Show all the information if false.
     *                                                 Use a summarised template if True.
     */
    function showInformation($insertBreak = false, $short = false)
    {   
        global $prefs, $thor;
        
        $projectData = $this->toArray();
        $projectName = $this->getName();
        $leftHeaderText = '';
        $rightHeaderText = '';
        $parents = explode(':', $projectName);
        if (!empty($parents)) {
            foreach($parents as $id => $parentName) {
                $cumName = ($id == 0) ? $cumName = $parentName : $cumName = $cumName . ':' . $parentName;
                if ($parentName != $projectData['project_name']) {
                    $url = Horde::applicationUrl(Util::addParameter('view.php', 'project_id', $thor->_projectsContainer->getProjectId($cumName)));
                    $parentLink = Horde::link($url, $parentName) . htmlspecialchars($parentName) . '</a>';
                    $leftHeaderText = $leftHeaderText . $parentLink . ' : ' ;
                }
            }
        } 
        $leftHeaderText = $leftHeaderText . htmlspecialchars($projectData['project_name']);
        if ($this->isUserOfKind(Auth::getAuth(), USERS_ADMINS)) {
            $url = Util::addParameter('project.php', 'project_id', $projectData['project_id']);
            $rightHeaderText = Horde::link(Horde::applicationUrl($url), _("Edit Project")) . Horde::img('add.png', _("Edit Project"), 'hspace="2"');
        } elseif(!$this->isUserOfKind(Auth::getAuth(), USERS_TEAM)) {
            $url = Horde::applicationUrl(Util::addParameter('view.php', array('join' => 1, 'project_id' => $projectData['project_id'])));
            $rightHeaderText = Horde::link($url,'','','',"return window.confirm('" . addslashes(sprintf(_("Are you sure you want to join '%s' ?"), $projectName)) . "');") . _("Join Project") . '</a>';
        }
        
        require THOR_TEMPLATES . '/section-header.inc';
        if ($short) {
            require THOR_TEMPLATES . '/view/SoftwareProject/short_description.inc';
        } else {
            require THOR_TEMPLATES . '/view/SoftwareProject/description.inc';
        }
        require THOR_TEMPLATES . '/view/footer.inc';
    }
    
    function initialize()
    {
        return parent::initialize();
    }
       
    function _destroy()
    {
        return parent::_destroy();
    }
}

/**
 * SoftwareProjectForm Class
 *
 * $Horde: thor/lib/Project/SoftwareProject.php,v 1.15 2004/10/11 22:07:21 carlos Exp $
 *
 * @author  Carlos Pedrinaci <cpedrinaci@yahoo.es>
 * @version $Revision: 1.15 $
 * @package Thor
 */
class SoftwareProjectForm extends Horde_Form {

    var $_useFormToken = false;

    function SoftwareProjectForm(&$vars)
    {
        $pid = $vars->get('project_id');
        $title = empty($pid) ? _("Create Project - Step 2") : _("Edit Software Project");
        parent::Horde_Form($vars, $title);
        // Add specific vars
        $params = array('', 40, 100);
        $list = DataTreeObject_SoftwareProject::getEnvList();
        $params1 = array($list, count($list) < 8 ? count($list) : 8 );
        $list = DataTreeObject_SoftwareProject::getOSList();
        $params2 = array($list, count($list) < 8 ? count($list) : 8);
        $list = DataTreeObject_SoftwareProject::getProgLangList();
        $params3 = array($list, count($list) < 8 ? count($list) : 8);
        $params4 = array(DataTreeObject_SoftwareProject::getDevStatusList(), true);
        $this->addVariable(_("Environment"), 'software_environment', 'multienum', true, false, null, $params1);
        $this->addVariable(_("Operating System(s)"), 'software_os', 'multienum', true, false, null, $params2);
        $this->addVariable(_("Programming Language(s)"), 'software_prog_lang', 'multienum', true, false, null, $params3);
        $this->addVariable(_("Development Status"), 'software_dev_status', 'enum', true, false, null, $params4);
    }
    
}